import { useState, useCallback, useMemo, useEffect } from 'react';

function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e,
      n,
      i,
      u,
      a = [],
      f = !0,
      o = !1;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
    } catch (r) {
      o = !0, n = r;
    } finally {
      try {
        if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var useAxiosLoader = function useAxiosLoader(axios) {
  var ignoredUrls = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    counter = _useState2[0],
    setCounter = _useState2[1];
  var inc = useCallback(function () {
    return setCounter(function (counter) {
      return counter + 1;
    });
  }, [setCounter]);
  var dec = useCallback(function () {
    return setCounter(function (counter) {
      return counter - 1;
    });
  }, [setCounter]);
  var urlIsIgnored = function urlIsIgnored(url) {
    return ignoredUrls.some(function (ignoredUrl) {
      return ignoredUrl.test(url);
    });
  };
  var interceptors = useMemo(function () {
    return {
      request: function request(config) {
        return !urlIsIgnored(config.url) && inc(), config;
      },
      response: function response(_response) {
        return counter >= 0 && dec(), _response;
      },
      // Decrement ONLY if counter has been incremented (avoid minus values)
      error: function error(_error) {
        return counter >= 0 && dec(), Promise.reject(_error);
      }
    };
  }, [inc, dec]); // create the interceptors

  useEffect(function () {
    // add request interceptors
    var reqInterceptor = axios.interceptors.request.use(interceptors.request, interceptors.error);
    // add response interceptors
    var resInterceptor = axios.interceptors.response.use(interceptors.response, interceptors.error);
    return function () {
      // remove all intercepts when done
      axios.interceptors.request.eject(reqInterceptor);
      axios.interceptors.response.eject(resInterceptor);
    };
  }, [interceptors]);
  counter < 0 && setCounter(0);
  return [counter > 0];
};

export { useAxiosLoader };
//# sourceMappingURL=index.es.js.map
